<template>
  <BasicModal v-bind="$attrs" :title="title" @register="registerInnerModal" :width="800">
    <template #footer>
      <div v-if="isUpdate !== 3">
        <a-button type="default" @click="handleCancle">取消</a-button>
        <a-button type="primary" @click="handleSubmit">确认</a-button>
      </div>
    </template>
    <BasicForm @register="registerForm" />
  </BasicModal>
</template>

<script setup lang="ts">
import { BasicModal, useModalInner } from "@/components/Modal";
import { BasicForm, useForm } from "@/components/Form";
import { computed, ref, unref } from "vue";
import {
  blackBoxInfoInfo,
  blackBoxInfoAdd,
  blackBoxInfoUpdate,
} from "@/api/blackBoxManage/blackBoxTim";
import { modalSchemas } from "./blackBoxInfo.data";
import { departmentTree } from "@/api/system/user";
import { addFullName } from "@/utils/helper/treeHelper";
import { postOptionSelect } from "@/api/system/post";
defineOptions({ name: "BlackBoxInfoModal" });

const emit = defineEmits(["register", "reload"]);

const isUpdate = ref<number>(1);
const title = computed<string>(() => {
  return isUpdate.value === 1
    ? "编辑黑匣子信息"
    : isUpdate.value === 2
    ? "新增黑匣子信息"
    : "查看黑匣子信息";
});

const [registerInnerModal, { modalLoading, closeModal }] = useModalInner(
  async (data: { record?: Recordable; update: number }) => {
    modalLoading(true);
    const { record, update } = data;
    isUpdate.value = update;
    await initDeptSelect();
    if (isUpdate.value === 3) {
      setProps({ disabled: true });
    } else {
      setProps({ disabled: false });
    }
    if ((update === 1 || update === 3) && record) {
      const ret = await blackBoxInfoInfo(record.id);
      await setFieldsValue(ret);
    }
    modalLoading(false);
  }
);

const [
  registerForm,
  { setFieldsValue, resetForm, validate, setProps, updateSchema },
] = useForm({
  labelWidth: 150,
  showActionButtonGroup: false,
  baseColProps: { span: 12 },
  schemas: modalSchemas,
});
function handleCancle() {
  closeModal();
  resetForm();
}
/**
 * 初始化部门选择
 */
const postList = ref<Post[]>([]);
async function initDeptSelect() {
  // updateSchema
  const deptTree = await departmentTree();
  // 选中后显示在输入框的值 即父节点 / 子节点
  addFullName(deptTree, "label", " / ");
  await updateSchema([
    {
      field: "deptId",
      componentProps: ({ formModel }) => ({
        treeData: deptTree,
        fieldNames: { value: "id", label: "label" },
        treeDefaultExpandAll: true,
        treeLine: { showLeafIcon: false },
        // 选中后显示在输入框的值
        treeNodeLabelProp: "fullName",
        async onSelect(deptId: string | number) {
          /** 根据部门ID加载岗位 */
          const postListResp = await postOptionSelect(deptId);
          postList.value = postListResp;
          /** 变化后需要重新选择岗位 */
          formModel.postIds = [];
        },
      }),
    },
  ]);
}
async function handleSubmit() {
  try {
    modalLoading(true);
    const data = await validate();
    if (isUpdate.value === 1) {
      await blackBoxInfoUpdate(data);
    } else {
      await blackBoxInfoAdd(data);
    }
    emit("reload");
    closeModal();
    await resetForm();
  } catch (e) {
    console.warn(e);
  } finally {
    modalLoading(false);
  }
}
</script>

<style scoped></style>
